package com.pyvio.openapi.sdk.entity.payment;

import com.pyvio.openapi.sdk.client.Endpoint;
import com.pyvio.openapi.sdk.client.PyvioRequest;
import com.pyvio.openapi.sdk.entity.info.PayerInfo;
import com.pyvio.openapi.sdk.entity.info.PaymentContractOrderInfo;
import com.pyvio.openapi.sdk.entity.info.PaymentPayeeInfo;

import java.math.BigDecimal;
import java.util.List;

public class PaymentCreateRequest extends PyvioRequest<PaymentDTO> {

    private String partner_order_id;
    private String order_type;
    private String rate_id;
    private String cal_origin;
    private BigDecimal amount;
    private String origin_currency;
    private String target_currency;
    private String payee_id;
    private PaymentPayeeInfo payee;
    private String charge_indicator;
    private String pobo;
    private PayerInfo payer;
    private String postscript;
    private String purpose;
    private String documents;
    private String remarks;
    private List<PaymentContractOrderInfo> contract_order_list;

    public PaymentPayeeInfo getPayee() {
        return payee;
    }

    public void setPayee(PaymentPayeeInfo payee) {
        this.payee = payee;
    }

    public PayerInfo getPayer() {
        return payer;
    }

    public void setPayer(PayerInfo payer) {
        this.payer = payer;
    }

    public String getPostscript() {
        return postscript;
    }

    public void setPostscript(String postscript) {
        this.postscript = postscript;
    }

    public List<PaymentContractOrderInfo> getContract_order_list() {
        return contract_order_list;
    }

    public void setContract_order_list(List<PaymentContractOrderInfo> contract_order_list) {
        this.contract_order_list = contract_order_list;
    }

    public void setPartner_order_id(String partner_order_id) {
        this.partner_order_id = partner_order_id;
    }

    public String getPartner_order_id() {
        return partner_order_id;
    }

    public void setOrder_type(String order_type) {
        this.order_type = order_type;
    }

    public String getOrder_type() {
        return order_type;
    }

    public void setRate_id(String rate_id) {
        this.rate_id = rate_id;
    }

    public String getRate_id() {
        return rate_id;
    }

    public void setCal_origin(String cal_origin) {
        this.cal_origin = cal_origin;
    }

    public String getCal_origin() {
        return cal_origin;
    }

    public void setAmount(BigDecimal amount) {
        this.amount = amount;
    }

    public BigDecimal getAmount() {
        return amount;
    }

    public void setOrigin_currency(String origin_currency) {
        this.origin_currency = origin_currency;
    }

    public String getOrigin_currency() {
        return origin_currency;
    }

    public void setTarget_currency(String target_currency) {
        this.target_currency = target_currency;
    }

    public String getTarget_currency() {
        return target_currency;
    }

    public void setPayee_id(String payee_id) {
        this.payee_id = payee_id;
    }

    public String getPayee_id() {
        return payee_id;
    }

    public void setCharge_indicator(String charge_indicator) {
        this.charge_indicator = charge_indicator;
    }

    public String getCharge_indicator() {
        return charge_indicator;
    }

    public void setRemarks(String remarks) {
        this.remarks = remarks;
    }

    public String getRemarks() {
        return remarks;
    }

    public void setPurpose(String purpose) {
        this.purpose = purpose;
    }

    public String getPurpose() {
        return purpose;
    }

    public void setDocuments(String documents) {
        this.documents = documents;
    }

    public String getDocuments() {
        return documents;
    }

    public String getPobo() {
        return pobo;
    }

    public void setPobo(String pobo) {
        this.pobo = pobo;
    }

    @Override
    public Endpoint getEndPointEnum() {
        return Endpoint.PaymentCreate;
    }
}
