import com.alibaba.fastjson.JSONObject;
import com.pyvio.openapi.sdk.client.Endpoint;
import com.pyvio.openapi.sdk.client.PyvioClient;
import com.pyvio.openapi.sdk.entity.balance.*;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class BalanceTest extends BaseTest {
    private static final Logger log = LoggerFactory.getLogger(BaseTest.class);

    @Test
    public void testGetBalance() {
        log.info("------------testGetBalance---------------");
        PyvioClient pyvioClient = getClient(Endpoint.BalanceGet);

        BalanceGetRequest request = new BalanceGetRequest();

        Map<String, String> header = new HashMap<>();
        header.put("X-Unit-Id", "all");

        request.setHeader(header);

        BalanceGetResponse response = pyvioClient.execute(request);
        System.out.println(JSONObject.toJSONString(response));
        log.info("------------testGetBalance---------------");
    }

    @Test
    public void testBalanceHistory() {
        log.info("------------testBalanceHistory---------------");
        PyvioClient pyvioClient = getClient(Endpoint.BalanceHistory);

        BalanceHistoryRequest request = new BalanceHistoryRequest();
//        request.setAccount_type("2");

        BalanceHistoryResponse response = (BalanceHistoryResponse)pyvioClient.execute(request);
        System.out.println(JSONObject.toJSONString(response));
        log.info("------------testBalanceHistory---------------");
    }

    @Test
    public void testBalanceListGet() {
        log.info("------------testBalanceListGet---------------");
        PyvioClient pyvioClient = getClient(Endpoint.BalanceList);

        BalanceListGetRequest request = new BalanceListGetRequest();
//        request.setAccount_type("2");

        BalanceListGetResponse response = (BalanceListGetResponse)pyvioClient.execute(request);
        System.out.println(JSONObject.toJSONString(response));
        log.info("------------testBalanceListGet---------------");
    }

}
