import com.alibaba.fastjson.JSONObject;
import com.pyvio.openapi.sdk.client.Endpoint;
import com.pyvio.openapi.sdk.client.PyvioClient;
import com.pyvio.openapi.sdk.entity.collection.*;
import com.pyvio.openapi.sdk.entity.info.AttachmentInfo;
import com.pyvio.openapi.sdk.enums.CollectionEnum;
import com.pyvio.openapi.sdk.enums.GlobalAccountEnum;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

public class CollectionTest extends BaseTest {
    private static final Logger log = LoggerFactory.getLogger(BaseTest.class);

    @Test
    public void testCollectionList() {
        log.info("------------testCollectionList---------------");
        CollectionListRequest request = new CollectionListRequest();

        PyvioClient pyvioClient = getClient(Endpoint.CollectionList);

        CollectionListResponse response = (CollectionListResponse)pyvioClient.execute(request);

        System.out.println(JSONObject.toJSONString(response));
        log.info("------------testCollectionList---------------");
    }

    @Test
    public void testCollectionGet() {
        log.info("------------testCollectionGet---------------");
        CollectionGetRequest request = new CollectionGetRequest();
        request.setOrder_id("V230825151694978045002467591");

        PyvioClient pyvioClient = getClient(Endpoint.CollectionGet);

        CollectionDTO response = pyvioClient.execute(request);

        System.out.println(JSONObject.toJSONString(response));
        log.info("------------testCollectionGet---------------");
    }

    @Test
    public void testCollectionAttachmentSubmit() {
        log.info("------------testCollectionAttachmentSubmit---------------");
        CollectionAttachmentSubmitRequest request = new CollectionAttachmentSubmitRequest();
        request.setOrder_id("VC2407261816689903496939103");
        request.setAttachment_type("WF-NORMAL");

        AttachmentInfo attachmentInfo1 = new AttachmentInfo();
        attachmentInfo1.setFile_id("0e4c1049f9ef4103be3c84e75a366d3a");
        attachmentInfo1.setFil_type(CollectionEnum.FilesType.Contract.getCode());
        AttachmentInfo attachmentInfo2 = new AttachmentInfo();
        attachmentInfo2.setFile_id("0e4c1049f9ef4103be3c84e75a366d3a");
        attachmentInfo2.setFil_type(CollectionEnum.FilesType.BankReceipt.getCode());
        AttachmentInfo attachmentInfo3 = new AttachmentInfo();
        attachmentInfo3.setFile_id("0e4c1049f9ef4103be3c84e75a366d3a");
        attachmentInfo3.setFil_type(CollectionEnum.FilesType.ShippingReceipt.getCode());

        List<AttachmentInfo> attachmentInfos = new ArrayList<>();
        attachmentInfos.add(attachmentInfo1);
        attachmentInfos.add(attachmentInfo2);
        attachmentInfos.add(attachmentInfo3);

        request.setFiles(attachmentInfos);

        PyvioClient pyvioClient = getClient(Endpoint.CollectionAttachmentSubmit);

        CollectionAttachmentSubmitResponse response = pyvioClient.execute(request);

        System.out.println(JSONObject.toJSONString(response));
        log.info("------------testCollectionAttachmentSubmit---------------");
    }

}
