import com.alibaba.fastjson.JSON;
import com.pyvio.openapi.sdk.client.Endpoint;
import com.pyvio.openapi.sdk.client.PyvioClient;
import com.pyvio.openapi.sdk.entity.fx.*;
import com.pyvio.openapi.sdk.enums.CalOriginEnum;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Map;


public class FxTest extends BaseTest{

    private static final Logger log = LoggerFactory.getLogger(BaseTest.class);


    @Test
    public void testQueryFxRateRequest() {
        log.info("------------testQueryFxRateRequest---------------");
        PyvioClient client = getClient(Endpoint.QueryFxRate);
        QueryFxRateRequest request = new QueryFxRateRequest();
        request.setOrigin_currency("VND");
        request.setTarget_currency("USD");
        QueryFxRateResponse execute = client.execute(request);
        System.out.println(JSON.toJSONString(execute));
        log.info("------------testQueryFxRateRequest---------------");
    }

    @Test
    public void testFxOrderCreateRequest() {
        log.info("------------testFxOrderCreateRequest---------------");
        PyvioClient client = getClient(Endpoint.FxOrderCreate);
        FxOrderCreateRequest request = new FxOrderCreateRequest();
        request.setPartner_order_id("fx"+System.currentTimeMillis());
        request.setOrigin_currency("VND");
        request.setTarget_currency("USD");
        request.setRate_id("240905151831530190023500277");
        request.setAmount(BigDecimal.valueOf(12345.00));
        request.setCal_origin(CalOriginEnum.Type.ORIGIN2TARGET.getCode());
        FxOrderDTO execute = client.execute(request);
        System.out.println(JSON.toJSONString(execute));
        log.info("------------testFxOrderCreateRequest---------------");
    }

    @Test
    public void testFxOrderQueryRequest() {
        log.info("------------testQueryFxRateRequest---------------");
        PyvioClient client = getClient(Endpoint.FxOrderQuery);
        FxOrderQueryRequest request = new FxOrderQueryRequest();
        request.setOrder_id("HH002404221781196539201491375");
        FxOrderDTO execute = client.execute(request);
        System.out.println(JSON.toJSONString(execute));
        log.info("------------testQueryFxRateRequest---------------");
    }

    @Test
    public void testFxOrderListRequest() {
        log.info("------------testQueryFxRateRequest---------------");
        PyvioClient client = getClient(Endpoint.FxOrderList);
        FxOrderListRequest request = new FxOrderListRequest();
        request.setPage_no(1);
        request.setPage_size(20);
        FxOrderListResponse execute = (FxOrderListResponse) client.execute(request);
        System.out.println(JSON.toJSONString(execute));
        log.info("------------testQueryFxRateRequest---------------");
    }

}
