import com.alibaba.fastjson.JSONObject;
import com.pyvio.openapi.sdk.client.Endpoint;
import com.pyvio.openapi.sdk.client.PyvioClient;
import com.pyvio.openapi.sdk.entity.globalAccount.*;
import com.pyvio.openapi.sdk.enums.GlobalAccountEnum;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.HashMap;
import java.util.Map;

public class GlobalAccountTest extends BaseTest{
    private static final Logger log = LoggerFactory.getLogger(BaseTest.class);

    @Test
    public void testOpenGlobalAccount(){
        log.info("------------testOpenGlobalAccount---------------");
        PyvioClient pyvioClient = getClient(Endpoint.GlobalAccountOpen);

        GlobalAccountOpenRequest request = new GlobalAccountOpenRequest();
        Map<String, String> header = new HashMap<>();
        header.put("X-Unit-Id", "UT1800775179768735210");
        request.setHeader(header);

        request.setShop_id("1800775179768735214");
//        UT1777652043454820288
        request.setCountry("SG");
        request.setCurrency("SGD");
//        request.setMulti_currency("Y");
//        request.setAccount_purpose("02");
        request.setPartner_ga_id("pg"+System.currentTimeMillis());
        request.setPlatform(GlobalAccountEnum.Platform.Lazada.getCode());
        request.setBiz_type(GlobalAccountEnum.BizType.Collection.getCode());

        GlobalAccountDTO response = pyvioClient.execute(request);

        System.out.println(JSONObject.toJSONString(response));

        log.info(response.getGa_id());
        log.info("------------testOpenGlobalAccount---------------");
    }

    @Test
    public void testOpenGlobalAccountB2B(){
        log.info("------------testOpenGlobalAccount---------------");
        PyvioClient pyvioClient = getClient(Endpoint.GlobalAccountOpen);

        GlobalAccountOpenRequest request = new GlobalAccountOpenRequest();

        request.setCountry("VN");
        request.setCurrency("VND");
//        request.setMulti_currency("Y");
//        request.setAccount_purpose("02");
        request.setPartner_ga_id("pg"+System.currentTimeMillis());
        request.setBiz_type(GlobalAccountEnum.BizType.DirectPayment.getCode());

        GlobalAccountDTO response = pyvioClient.execute(request);

        System.out.println(JSONObject.toJSONString(response));

        log.info(response.getGa_id());
        log.info("------------testOpenGlobalAccount---------------");
    }

    @Test
    public void testGetGlobalAccount(){
        log.info("------------testGetGlobalAccount---------------");
        PyvioClient pyvioClient = getClient(Endpoint.GlobalAccountOpen);

        GlobalAccountGetRequest request = new GlobalAccountGetRequest();
        request.setGa_id("va1777652043454820306");

        GlobalAccountDTO response = pyvioClient.execute(request);
        System.out.println(JSONObject.toJSONString(response));
        log.info("------------testGetGlobalAccount---------------");
    }

    @Test
    public void testListGlobalAccount(){
        log.info("------------testListGlobalAccount---------------");
        PyvioClient pyvioClient = getClient(Endpoint.GlobalAccountList);

        GlobalAccountListRequest request = new GlobalAccountListRequest();


        Map<String, String> header = new HashMap<>();
        header.put("X-Unit-Id", "ALL");
        request.setHeader(header);
        request.setPage_no(1);
        request.setPage_size(1);

        GlobalAccountListResponse response = (GlobalAccountListResponse) pyvioClient.execute(request);
        System.out.println(JSONObject.toJSONString(response));
        log.info("------------testListGlobalAccount---------------");

    }

    @Test
    public void testGlobalAccountGetWelcomeLetterRequest() {
        log.info("------------testListGlobalAccount---------------");
        PyvioClient pyvioClient = getClient(Endpoint.GlobalAccountGetWelcomeLetterGet);
        GlobalAccountGetWelcomeLetterRequest request = new GlobalAccountGetWelcomeLetterRequest();
        request.setGa_id("va1800775179768735215");

        Map<String, String> header = new HashMap<>();
        header.put("X-Unit-Id", "UT1800775179768735210");
        request.setHeader(header);

        GlobalAccountGetWelcomeLetterResponse response = pyvioClient.execute(request);

        System.out.println(JSONObject.toJSONString(response));

        log.info("------------testListGlobalAccount---------------");

    }

}
