import com.alibaba.fastjson.JSONObject;
import com.pyvio.openapi.sdk.client.Endpoint;
import com.pyvio.openapi.sdk.client.PyvioClient;
import com.pyvio.openapi.sdk.entity.report.ReportListRequest;
import com.pyvio.openapi.sdk.entity.report.ReportListResponse;
import com.pyvio.openapi.sdk.entity.unit.UnitGetRequest;
import com.pyvio.openapi.sdk.entity.unit.UnitGetResponse;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ReportTest extends BaseTest {
    private static final Logger log = LoggerFactory.getLogger(BaseTest.class);

    @Test
    public void testReportUnit() {
        log.info("------------testReportUnit---------------");
        PyvioClient pyvioClient = getClient(Endpoint.ReportList);

        ReportListRequest request = new ReportListRequest();
        request.setPage_no(1);
        request.setPage_size(1);
        request.setBill_date_from("1718035200000");
        request.setBill_date_to("1718121599999");
        request.setBill_date_type("Day");

        ReportListResponse response = pyvioClient.execute(request);
        System.out.println(JSONObject.toJSONString(response));
        log.info("------------testReportUnit---------------");
    }

}
