import com.alibaba.fastjson.JSONObject;
import com.pyvio.openapi.sdk.client.Endpoint;
import com.pyvio.openapi.sdk.client.PyvioClient;
import com.pyvio.openapi.sdk.entity.shop.*;
import com.pyvio.openapi.sdk.enums.GlobalAccountEnum;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.HashMap;
import java.util.Map;

public class ShopTest extends BaseTest {

    private static final Logger log = LoggerFactory.getLogger(BaseTest.class);

    @Test
    public void testShopCreate() {
        log.info("------------testShopCreate---------------");

        ShopCreateRequest request = new ShopCreateRequest();
        Map<String, String> headers = new HashMap<>();
        headers.put("X-Unit-Id", "UT1800775179768735210");
        request.setHeader(headers);

        request.setPlatform(GlobalAccountEnum.Platform.AppStore.getCode());
        request.setSite("US");
        request.setCurrency("USD");
        request.setShop_name("shop name");
        request.setShop_link("https://link.com");
        request.setApplication_type("Tool");
        request.setApi_key("apikey");
        request.setApi_secret("secret");
        request.setAuth_file_id("2f435a7b657a4b0784f75d41ca4c9979");


//        request.setPlatform(GlobalAccountEnum.Platform.Lazada.getCode());
//        request.setShop_name("shop name123q");
//        request.setShop_owner("shop owner");
//        request.setSite("SG");
//        request.setCurrency("SGD");
//        request.setShop_link("https://1245.com");
//        request.setSelling_goods("goods");
////        request.setAcquirer(GlobalAccountEnum.Acquirer.PayPal.getCode());


        PyvioClient pyvioClient = getClient(Endpoint.ShopCreate);

        ShopDTO response = pyvioClient.execute(request);
        System.out.println(JSONObject.toJSONString(response));

        log.info("------------testShopCreate---------------");

    }

    @Test
    public void testShopGet() {
        log.info("------------testShopGet---------------");

        ShopGetRequest request = new ShopGetRequest();

        request.setShop_id("1777652043454820105");

        PyvioClient pyvioClient = getClient(Endpoint.ShopGet);

        ShopDTO response = pyvioClient.execute(request);
        System.out.println(JSONObject.toJSONString(response));
        log.info("------------testShopGet---------------");
    }

    @Test
    public void testShopList() {
        log.info("------------testShopList---------------");
        ShopListRequest request = new ShopListRequest();

        PyvioClient pyvioClient = getClient(Endpoint.ShopList);

        ShopListResponse response = (ShopListResponse)pyvioClient.execute(request);

        System.out.println(JSONObject.toJSONString(response));
        log.info("------------testShopList---------------");
    }


    @Test
    public void testShopUpdate() {
        log.info("------------testShopCreate---------------");

        ShopUpdateRequest request = new ShopUpdateRequest();
        Map<String, String> headers = new HashMap<>();
        headers.put("X-Unit-Id", "UT1675766643661405569");
        request.setHeader(headers);

        request.setPlatform(GlobalAccountEnum.Platform.Lazada.getCode());
        request.setShop_id("1777652043454820289");
        request.setShop_name("shop name test1");
        request.setShop_owner("shop owner");
        request.setSite("VN");
        request.setCurrency("VND");
        request.setShop_link("https://1245.com");
        request.setSelling_goods("goods");
        request.setAcquirer(GlobalAccountEnum.Acquirer.PayPal.getCode());
        request.setApi_key("apikey");
        request.setApi_secret("apisec");
        request.setLegal_no("legal no");
        request.setStore_id("store id");
        request.setSales_category("BOOK_MUSIC");

        PyvioClient pyvioClient = getClient(Endpoint.ShopUpdate);

        ShopDTO response = pyvioClient.execute(request);
        System.out.println(JSONObject.toJSONString(response));

        log.info("------------testShopUpdate---------------");

    }

}
