import com.alibaba.fastjson.JSONObject;
import com.pyvio.openapi.sdk.client.Endpoint;
import com.pyvio.openapi.sdk.client.PyvioClient;
import com.pyvio.openapi.sdk.entity.transfer.*;
import com.pyvio.openapi.sdk.entity.unit.UnitGetRequest;
import com.pyvio.openapi.sdk.entity.unit.UnitGetResponse;
import org.junit.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Map;

public class TransferTest extends BaseTest{

    private static final Logger log = LoggerFactory.getLogger(BaseTest.class);

    @Test
    public void testTransferCreateRequest() {
        log.info("------------testTransferCreateRequest---------------");
        PyvioClient pyvioClient = getClient(Endpoint.TransferCreate);

        TransferCreateRequest request = new TransferCreateRequest();

        Map<String, String> header = new HashMap<>();
        header.put("X-Unit-Id", "UT1800775179768735210");
        request.setHeader(header);

        request.setPartner_order_id("t"+System.currentTimeMillis());
        request.setPayee_unit_id("UT1675766643661405569");
        request.setCurrency("USD");
        request.setAmount(BigDecimal.valueOf(306.900));
        request.setPurpose("transfer");

        TransferDTO response = pyvioClient.execute(request);
        System.out.println(JSONObject.toJSONString(response));
        log.info("------------testTransferCreateRequest---------------");
    }

    @Test
    public void testTransferGetRequest() {
        log.info("------------testTransferGetRequest---------------");
        PyvioClient pyvioClient = getClient(Endpoint.TransferGet);

        TransferGetRequest request = new TransferGetRequest();
        request.setPartner_order_id("t1713843657674");

        TransferDTO response = pyvioClient.execute(request);
        System.out.println(JSONObject.toJSONString(response));
        log.info("------------testTransferGetRequest---------------");
    }

    @Test
    public void testTransferListRequest() {
        log.info("------------testTransferListRequest---------------");
        PyvioClient pyvioClient = getClient(Endpoint.TransferList);

        TransferListRequest request = new TransferListRequest();
        request.setPage_no(1);
        request.setPage_size(20);
        TransferListResponse response =(TransferListResponse) pyvioClient.execute(request);
        System.out.println(JSONObject.toJSONString(response));
        log.info("------------testTransferListRequest---------------");
    }
}
